diff options
Diffstat (limited to 'test')
-rw-r--r-- | test/Makefile | 2 | ||||
-rwxr-xr-x | test/scripts/run_with_cleanup.sh | 25 |
2 files changed, 26 insertions, 1 deletions
diff --git a/test/Makefile b/test/Makefile index 14c8cd268ef..7416afc2295 100644 --- a/test/Makefile +++ b/test/Makefile @@ -76,7 +76,7 @@ $(PAPI_INSTALL_DONE): $(PIP_PATCH_DONE) @touch $@ define retest-func - @bash -c "source $(PYTHON_VENV_PATH)/bin/activate && python run_tests.py -d $(TEST_DIR) $(UNITTEST_EXTRA_OPTS)" + @bash -c "source $(PYTHON_VENV_PATH)/bin/activate && setsid scripts/run_with_cleanup.sh python run_tests.py -d $(TEST_DIR) $(UNITTEST_EXTRA_OPTS)" endef .PHONY: sanity diff --git a/test/scripts/run_with_cleanup.sh b/test/scripts/run_with_cleanup.sh new file mode 100755 index 00000000000..dcaa58b4498 --- /dev/null +++ b/test/scripts/run_with_cleanup.sh @@ -0,0 +1,25 @@ +#!/bin/bash + +rv=0 + +atexit() { + group_id=`ps -p $$ -o pgid=` + my_id=$$ + ids=`pgrep -g $group_id -d ' ' | sed "s/\b$my_id\b//g"` + echo "Killing possible remaining process IDs: $ids" + for id in $ids + do + if ps -p $id > /dev/null + then + kill -9 $id + fi + done + exit $rv +} + +trap "atexit" SIGINT SIGTERM + +$* +rv=$? +atexit +exit $rv |